import './style.scss'

const registerChromecastPlugin = require('@silvermine/videojs-chromecast')
const registerAirplayPlugin = require('@silvermine/videojs-airplay')

function register ({ registerHook, peertubeHelpers }) {
  registerHook({
    target: 'action:video-watch.video.loaded',
    handler: ({ videojs }) => {
      const script = document.createElement('script')
      script.src = 'https://www.gstatic.com/cv/js/sender/v1/cast_sender.js?loadCastFramework=1'
      document.body.appendChild(script)

      registerChromecastPlugin(videojs, { preloadWebComponents: true })
      registerAirplayPlugin(videojs)
    },
  })

  registerHook({
    target: 'filter:internal.player.videojs.options.result',
    handler: options => Object.assign(
      {},
      options,
      {
				chromecast: {
					modifyLoadRequestFn: function (loadRequest) {
						loadRequest.media.hlsSegmentFormat = 'fmp4';
						loadRequest.media.hlsVideoSegmentFormat = 'fmp4';
						return loadRequest;
					}
				},
        plugins: Object.assign(
          {},
          options.plugins,
          {
            chromecast: {},
            airPlay: {},
          }
        ),
        techOrder: ['chromecast', 'html5'],
      }
    ),
  })
}

export {
  register
}
